// Copyright (c) 2002 Cunningham & Cunningham, Inc.
// Released under the terms of the GNU General Public License version 2 or later.

// Warning: not (yet) a general number usable in all calculations.

namespace fit
{
	public class ScientificDouble
	{
		double value;
		double precision;

		public ScientificDouble(double value)
		{
			this.value = value;
			this.precision = 0;
		}

		public static ScientificDouble valueOf(string s) 
		{
			ScientificDouble result = new ScientificDouble(double.Parse(s));
			result.precision = measurePrecision(s);
			return result;
		}

		public static double measurePrecision(string s) 
		{
			double precision = 5;
			for (int i=0; i<s.Length; i++) 
			{
				char ch = s[i];
				if (char.IsDigit(ch)) 
				{
					precision /= 10;
				} 
				else if (char.ToLower(ch) == 'e') 
				{
					break;
				}
			}
			return precision;
		}

		public static ScientificDouble Parse(string s)
		{
			return valueOf(s);
		}

		public override bool Equals(object obj) 
		{
			return compareTo(obj) == 0;
		}

		public int compareTo(object obj) 
		{
			double other = ((ScientificDouble)obj).doubleValue();
			double diff = (value-other)/value;
			// System.out.println(value+" "+precision+" "+diff);
			if (diff < -precision) return -1;
			if (diff > precision) return 1;
			if (double.IsNaN(value) && double.IsNaN(other)) return 0;
			if (double.IsNaN(value)) return 1;
			if (double.IsNaN(other)) return -1;
			return 0;
		}

		public override string ToString() 
		{
			return value.ToString();
		}

		public override int GetHashCode()
		{
			return (int)value;
		}

		public double doubleValue() 
		{
			return value;
		}

		public float floatValue() 
		{
			return (float)value;
		}

		public long longValue() 
		{
			return (long)value;
		}

		public int intValue() 
		{
			return (int)value;
		}
	}
}